import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;

/**
 * 
 * @author kurokiyuta GUI쐬NX
 */
public class SetUpGui {
    private final int COLUMNS = 8;

    Action actionManager = new Action();

    private JFrame frame;

    private Container cp;

    private JPanel allPanel, leftPanel, rightPanel, checkBoxPanel,
            selectNumberPanel;

    private DefaultTableModel tableModel;

    private JTable fileTable;

    private JTableHeader fileTableHeader;

    private JScrollPane fileScroll, checkScroll;

    private TitledBorder fileTitle;

    private Object[] checkObject;

    private DefaultListModel listModel;

    private JList listRoom;

    private JSplitPane splitPanel;

    private JTextField startNumberField, endNumberField, frequencyNumberField;

    private int startNumber, endNumber, frequencyNumber;

    private String startNumberFieldString, endNumberFieldString,
            frequencyNumberFieldString;// eLXgtB[hɓ͂ꂽLϐ

    /*
     * EChE郁\bh
     */
    public void makeWindow() {
        frame = new JFrame("SimData Manager");
        cp = frame.getContentPane();
        // EBhE㕔̃N[Y{^ꂽI悤ɐݒ
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosed(WindowEvent e) {
                System.exit(0);
            }
        });

    }

    /*
     * pl̐ݒu
     */

    public void newPanels() {
        splitPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        allPanel = new JPanel();
        allPanel.setLayout(new BoxLayout(allPanel, BoxLayout.X_AXIS));
        leftPanel = new JPanel();
        leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.Y_AXIS));
        rightPanel = new JPanel();
        rightPanel.setLayout(new BoxLayout(rightPanel, BoxLayout.Y_AXIS));
        checkBoxPanel = new JPanel();
        checkBoxPanel.setLayout(new GridLayout(2, 5));
        selectNumberPanel = new JPanel();
        // frequencyNumberPanel = new JPanel();

    }

    /*
     * j[o[̍쐬
     */
    public void menuBar() {
        JMenuBar mb = new JMenuBar();
        JMenu mFile = new JMenu("t@C");
        JMenuItem ref = new JMenuItem("t@C̓ǂݍ");
        JMenuItem addRoad = new JMenuItem("ǉǂݍ");
        JMenuItem exit = new JMenuItem("I");

        mFile.add(ref);
        mFile.add(addRoad);
        mFile.add(exit);
        mb.add(mFile);
        frame.getRootPane().setJMenuBar(mb);
        ref.addActionListener(actionManager);
        ref.setActionCommand("pushref");
        addRoad.addActionListener(actionManager);
        addRoad.setActionCommand("pushaddRoad");
        exit.addActionListener(actionManager);
        exit.setActionCommand("pushexit");
    }

    /*
     * j[Xg郁\bh
     */
    public void makeMenuList() {
        JScrollPane sp = new JScrollPane();
        listModel = new DefaultListModel();
        listRoom = new JList(listModel);
        sp.setBorder(new TitledBorder("t@Cꗗ"));
        sp.getViewport().setView(listRoom);
        sp.setPreferredSize(new Dimension(300, 500));
        JLabel deleteLabel = new JLabel("It@CXg폜");
        JButton deleteButton = new JButton("폜");
        deleteButton.addActionListener(actionManager);
        deleteButton.setActionCommand("delete");
        JLabel extractLabel = new JLabel("It@C");
        JButton extractButton = new JButton("o");
        extractButton.addActionListener(actionManager);
        extractButton.setActionCommand("extract");
        listRoom.addListSelectionListener(actionManager);
        leftPanel.add(sp);
        leftPanel.add(deleteLabel);
        leftPanel.add(deleteButton);
        leftPanel.add(extractLabel);
        leftPanel.add(extractButton);
        // allPanel.add(leftPanel);
        splitPanel.setLeftComponent(leftPanel);

    }

    /*
     * t@C̒g\ꏊ郁\bh
     */
    public void makeFileView() {

        tableModel = new DefaultTableModel(0, 1000) {
            public boolean isCellEditable(int row, int column) {
                return false;
            }

        };

        fileTable = new JTable(tableModel);
        fileTable.setAutoResizeMode(0);
        fileTableHeader = fileTable.getTableHeader();
        fileTableHeader.setReorderingAllowed(false);
        fileScroll = new JScrollPane(fileTable);

        fileScroll.setPreferredSize(new Dimension(450, 350));

        // t@C\ɌݑI𒆂̃t@C\
        fileTitle = new TitledBorder("I𒆂̃t@C̕\");
        fileScroll.setBorder(fileTitle);

        rightPanel.add(fileScroll);

        makeCheckBox();// `FbN{bNX

        makeRowSelecter();// s͈͎wZN^[
        // makeFrequencySelecter();
        JButton outputButton = new JButton("o");
        // outputButton.setHorizontalAlignment(JButton.RIGHT);

        outputButton.addActionListener(actionManager);
        outputButton.setActionCommand("output");
        // JPanel outputPanel = new JPanel();
        // outputPanel.add(outputButton,BorderLayout.EAST);

        rightPanel.add(outputButton);
        // allPanel.add(rightPanel);
        splitPanel.setRightComponent(rightPanel);

    }

    /*
     * `FbN{bNX̍쐬
     */
    private void makeCheckBox() {
        checkScroll = new JScrollPane();
        JCheckBox cb1 = new JCheckBox();
        JCheckBox cb2 = new JCheckBox();
        JCheckBox cb3 = new JCheckBox();
        JCheckBox cb4 = new JCheckBox();
        JCheckBox cb5 = new JCheckBox();
        JCheckBox cb6 = new JCheckBox();
        JCheckBox cb7 = new JCheckBox();
        JCheckBox cb8 = new JCheckBox();
        JCheckBox cb9 = new JCheckBox();
        JCheckBox cb10 = new JCheckBox();
        checkObject = new Object[] { cb1, cb2, cb3, cb4, cb5, cb6, cb7, cb8,
                cb9, cb10 };
        for (int i = 0; i < checkObject.length; i++) {

            checkBoxPanel.add((Component) checkObject[i]);
            ((AbstractButton) checkObject[i]).setVisible(false);
            ((AbstractButton) checkObject[i]).setSelected(true);
        }
        checkScroll.getViewport().setView(checkBoxPanel);
        checkScroll.setBorder(new TitledBorder(" c̑I"));

        rightPanel.add(checkScroll);

    }

    /*
     * ͈͎w̃r[̍쐬
     */
    public void makeRowSelecter() {
        startNumberField = new JTextField("1");
        endNumberField = new JTextField("1000000");
        frequencyNumberField = new JTextField("1");

        startNumberField.setBorder(new TitledBorder("ŏ"));
        startNumberField.setColumns(COLUMNS);
        endNumberField.setBorder(new TitledBorder("Ō"));
        endNumberField.setColumns(COLUMNS);
        frequencyNumberField.setBorder(new TitledBorder("NsƂɏo"));
        frequencyNumberField.setColumns(COLUMNS);

        selectNumberPanel.setBorder(new TitledBorder("ś͈@px@I"));
        selectNumberPanel.add(startNumberField);
        selectNumberPanel.add(endNumberField);
        selectNumberPanel.add(frequencyNumberField);
        rightPanel.add(selectNumberPanel);

    }

    public void setView() {
        // cp.add(allPanel);
        cp.add(splitPanel);
        actionManager.setListModel(listModel);
        actionManager.setListRoom(listRoom);
        actionManager.setTableModel(tableModel);
        actionManager.setCheckObject(checkObject);
        actionManager.setSetUpGui(this);

        frame.setSize(900, 700);
        frame.setVisible(true);

    }

    /**
     * @return Returns the startNumber.
     */
    public int getStartNumber() {
        startNumber = 0;// 
        startNumberFieldString = startNumberField.getText();
        for (int i = 0; i < startNumberFieldString.length(); i++) {
            if (Character.isDigit(startNumberFieldString.charAt(i)) == false) {// ͒llł͂Ȃ
                startNumber = -1;// sȕ͂̏ꍇ-1
                continue;
            }
        }

        if (startNumber != -1) {
            startNumber = Integer.parseInt(startNumberFieldString);
        }
        if (startNumber == 0) {
            startNumber = -1;
        }
        System.out.println("startNumber ==" + startNumber);
        return startNumber;
    }

    /**
     * @return Returns the endNumber.
     */
    public int getEndNumber() {
        endNumber = 0;// 
        endNumberFieldString = endNumberField.getText();
        for (int i = 0; i < endNumberFieldString.length(); i++) {
            if (Character.isDigit(endNumberFieldString.charAt(i)) == false) {// ͒llł͂Ȃ
                endNumber = -1;// sȕ͂̏ꍇ-1
                continue;
            }
        }

        if (endNumber != -1) {
            endNumber = Integer.parseInt(endNumberFieldString);
        }
        if (startNumber >= endNumber) {// startNumberendNumber傫
            endNumber = -1;
        }
        System.out.println("endNumber ==" + endNumber);
        return endNumber;
    }

    /**
     * @return Returns the frequencyNumber.
     */
    public int getFrequencyNumber() {
        frequencyNumber = 0;// 
        frequencyNumberFieldString = frequencyNumberField.getText();
        for (int i = 0; i < frequencyNumberFieldString.length(); i++) {
            if (Character.isDigit(frequencyNumberFieldString.charAt(i)) == false) {// ͒llł͂Ȃ
                frequencyNumber = -1;// sȕ͂̏ꍇ-1
                continue;
            }
        }

        if (frequencyNumber != -1) {
            frequencyNumber = Integer.parseInt(frequencyNumberFieldString);
        }
        if (frequencyNumber == 0) {
            frequencyNumber = -1;
        }
        System.out.println("frequencyNumber ==" + frequencyNumber);
        return frequencyNumber;
    }

    /**
     * @return Returns the frame.
     */
    public JFrame getFrame() {
        return frame;
    }

}
